package easyaction;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * uEŨNGXg󂯕tActionNX邽߂̒ۃNXłB
 * eActionNX͂̃NXextendsKv܂B
 * ̃NXextendŝׂ͂ăXbhZ[tłB
 */
public abstract class Action {

	/**
	 * ActionɊ֘AÂĂRg[ServletłB
	 * ܂CuEU̗B̎tT[ubgłActionServletłB
	 */
	private HttpServlet _servlet;
    
	/**
	 * ActionɊ֘AÂĂRg[ServletiActionServletj̃CX^Xݒ肵܂B 
	 * @param servlet T[ubg
	 */
	public void setServlet(HttpServlet servlet) {
		if(servlet != null){
	        _servlet = servlet;
		}
    }
    
	/**
	 * ActionɊ֘AÂĂRg[ServletiActionServletj̃CX^XԂ܂B
	 * T[ubĝ낢ȃ\bh𗘗pƂɌĂяo܂BႦ΁CgetInitParameter
	 * getSrevletContext𗘗pꍇ
	 * <pre>
	 * String param = getServlet().getInitParameter("paramName");
	 * ServletContext sc = getServlet().getServletContext();
	 * </pre>
	 * ȂǂƂ܂B
	 * @return ActionɊ֘AÂĂRg[ServletiActionServletj̃CX^X
	 */
	public HttpServlet getServlet() {
        return _servlet;
    }
	
	/*
    //T[ubgNGXg
    private HttpServletRequest _request;
    
    public void setRequest(HttpServletRequest request) {
        _request = request;
    }
    
    //T[ubgX|X
    private HttpServletResponse _response;

    public void setResponse(HttpServletResponse response) {
        _response = response;
    }
	 */    

    /**
     * uEŨNGXg󂯕t܂B{IɁCHttpServletdoGetdoPostƓłB
     * strutsƈႢC߂lɂ́Cy[W̃AhX𒼐ڋL܂B
     * @param request NGXg
     * @param response X|X
     * @return y[W̃AhXi@/next.jsp j / Kvł̂ŒӂĂB
     * @throws IOException
     * @throws ServletException
     */
    public abstract String execute(HttpServletRequest request, HttpServletResponse response)
	throws IOException, ServletException;
    
    //t[
    /* ȉ̓{c
    public void saveCurrentAction(String actionName){
    	HttpSession session = _request.getSession(true);
    	session.setAttribute("previousAction", actionName);
    }
    
    public boolean isPreviousAction(String actionName){
    	HttpSession session = _request.getSession(true);
    	if(session.isNew()){
    		return false;
    	}else{
    		String previousAction = (String)session.getAttribute("previousAction");
    		if(previousAction != null && previousAction.equals(actionName)){
    			return true;
    		}else{
    			return false;
    		}
    	}
    }

    public void saveToken(){
        String token = Double.toString(Math.random());
    	
        Cookie cookie = new Cookie("previousPageOfCookie", token);
        // NbL[̗LԂ7ɐݒ(bPʂŎw)
        cookie.setMaxAge(3600 * 24 * 7);
        // NbL[𔭍s܂
        _response.addCookie(cookie);

    	HttpSession session = _request.getSession(true);
   		session.setAttribute("previousPageOfSession", token);
    }

    public boolean isTokenValid() {
		String previousPageOfCookie = null;
		
    	// ۑĂ邷ׂẴNbL[̔z擾܂
		Cookie[] cookies = _request.getCookies();
		if (cookies != null) {
			for (int i = 0; i < cookies.length; i++) {
				if (cookies[i].getName().equals("previousPageOfCookie")) {
					// YNbL[擾܂
					previousPageOfCookie = cookies[i].getValue();
					break;
				}
			}
		}
		if(previousPageOfCookie == null || previousPageOfCookie.equals("")){
			return false;
		}
		
		String previousPageOfSession;
    	HttpSession session = _request.getSession(true);
    	if(session.isNew()){
    		return false;
    	}else{
    		previousPageOfSession = (String)session.getAttribute("previousPageOfSession");
    	}
		if(previousPageOfSession == null || previousPageOfSession.equals("")){
			return false;
		}

		if(previousPageOfCookie.equals(previousPageOfSession)){
			return true;
		}else{
			return false;
		}
	}
    
    public void resetToken(){
        Cookie cookie = new Cookie("previousPageOfCookie", "");
        // NbL[̍폜
        cookie.setMaxAge(0);
        // NbL[𔭍s܂
        _response.addCookie(cookie);

    	HttpSession session = _request.getSession(true);
   		session.removeAttribute("previousPageOfSession");
    }
     */
    
    /**
     * j[NȕitransactionTokenj𐶐CsessionXR[vɊi[܂B
     * ܂CjspɂreauestXR[vƂđ܂B
     * {IɁCstrutssaveTokenƓłC̕󂯎jsp̕ŁC<br />
     * [NGXgAhX]?transactionToken=${requestScope.transactionToken}<br />
     * ̂悤ɁC󂯎transactionToken̂܂܃T[ubgiActionj֖߂ĂKv܂B
     * @param request NGXg
     */
    public void saveToken(HttpServletRequest request){
        String transactionToken = Double.toString(Math.random()).substring(2);
    	
    	HttpSession session = request.getSession(true);
   		session.setAttribute("transactionToken", transactionToken);

   		request.setAttribute("transactionToken", transactionToken);
    }

    /**
     * transactionTokenLǂׂ܂BQtrueɐݒ肷ƔCsessiontransactionToken
     * 폜܂B{IɁCstrutsisTokenValidƓłB܂C߂ltruêƂt[C
     * falsêƂsȃt[Ӗ܂B
     * @param request NGXg
     * @param reset sessiontransactionToken폜邩ǂ̃tOBtrueō폜CfalseŉȂ
     * @return L̂ƂtrueĈƂfalse
     */
    public boolean isTokenValid(HttpServletRequest request, boolean reset) {
		String transactionTokenFromJSP = (String)request.getAttribute("transactionToken");
		if(transactionTokenFromJSP == null){
			transactionTokenFromJSP = (String)request.getParameter("transactionToken");
		}
		if(transactionTokenFromJSP == null){
    		if(reset){
    			resetToken(request);
    		}
			return false;
		}
		
		String transactionTokenFromSession;
    	HttpSession session = request.getSession(true);
    	if(session.isNew()){
    		return false;
    	}else{
    		transactionTokenFromSession = (String)session.getAttribute("transactionToken");
    		if(reset){
    			resetToken(request);
    		}
    	}
		if(transactionTokenFromSession == null || transactionTokenFromSession.equals("")){
			return false;
		}

		if(transactionTokenFromJSP.equals(transactionTokenFromSession)){
			return true;
		}else{
			return false;
		}
	}
    
    /**
     * transactionTokenLǂׂ܂BisTokenValid(HttpServletRequest request, boolean reset)
     * resetfalsenꍇƓłB܂蔻CsessiontransactionToken͍폜܂B
     * {IɁCstrutsisTokenValidƓłB߂ltruêƂt[C
     * falsêƂsȃt[Ӗ܂B
     * @param request NGXg
     * @return L̂ƂtrueĈƂfalse
     */
    public boolean isTokenValid(HttpServletRequest request) {
    	return isTokenValid(request, false);
	}
    
    /**
     * sessiontransactionToken폜܂B{IɁCstrutsresetTokenƓłB
     * @param request NGXg
     */
    public void resetToken(HttpServletRequest request){
    	HttpSession session = request.getSession(true);
   		session.removeAttribute("transactionToken");
    }

    /** G[bZ[Wi[IuWFNg */
    private StringBuffer _errorMessage = new StringBuffer();

	/**
	 * G[bZ[Wi[܂B
	 * @param errorMessage G[bZ[W
	 */
    public void setErrorMessage(String errorMessage){
    	_errorMessage.append(errorMessage + "<br />\n");
    }

	/**
	 * SẴG[bZ[W擾܂B
	 * @param servlet G[bZ[W
	 */
    public String getErrorMessage(){
    	return _errorMessage.toString();
    }

    /**
     * G[bZ[Wi[Ă邩ǂׂ܂B
     * @return G[bZ[WƂtrueCȂƂfalse
     */
    public boolean existErrorMessage(){
		if(_errorMessage.length() > 0){
			return true;
		}else{
			return false;
		}
    }

	/**
	 * NGXgp[^擾܂BTj^CY{܂B
	 * HttpServletRequestgetParameterƂ̈Ⴂ́CTj^CYƂƂłB
	 * HttpServletRequestgetParameteřɕKTj^CŶłΎgpKv͂܂񂪁C
	 * Yۂl͂̃\bhɊƂ悢܂B
	 * @param request NGXg
	 * @param parameter p[^
	 * @return p[^̒l
	 */
	public String getParameter(HttpServletRequest request, String parameter){
		String parameterValue = null;
		parameterValue = request.getParameter(parameter);
		if(parameterValue == null){
			return null;
		}
		return sanitize(parameterValue);
	}
	
    /**
     * Tj^CY܂BistrutsResponseUtilsNXfilter\bhq؁j
     * @param value Tj^CY
     * @return Tj^CY̕
     */
    public String sanitize(String value) {

        if (value == null || value.length() == 0) {
            return value;
        }

        StringBuffer result = null;
        String filtered = null;
        for (int i = 0; i < value.length(); i++) {
            filtered = null;
            switch (value.charAt(i)) {
                case '<':
                    filtered = "&lt;";
                    break;
                case '>':
                    filtered = "&gt;";
                    break;
                case '&':
                    filtered = "&amp;";
                    break;
                case '"':
                    filtered = "&quot;";
                    break;
                case '\'':
                    filtered = "&#39;";
                    break;
            }

            if (result == null) {
                if (filtered != null) {
                    result = new StringBuffer(value.length() + 50);
                    if (i > 0) {
                        result.append(value.substring(0, i));
                    }
                    result.append(filtered);
                }
            } else {
                if (filtered == null) {
                    result.append(value.charAt(i));
                } else {
                    result.append(filtered);
                }
            }
        }

        return result == null ? value : result.toString();
    }
    	
}
